/*
cc -I/usr/include/mysql -L/usr/lib/mysql myapp.c -o myapp -lm -lmysqlclient 
*/

#include <gtk/gtk.h>
#include "briefomat.h"
#include "mysql/mysql.h" 

MYSQL mysql;
MYSQL_RES *res;
MYSQL_ROW row;



void exiterr(int exitcode)
        {
            fprintf( stderr, "%s\n", mysql_error(&mysql) );
            exit( exitcode );
        }

char *get_sql_list(char *server,char *database,char *table)
{
  char *querystr;
  uint i = 0;
  
  querystr = (gchar *)malloc(1000); 
  sprintf(querystr,"SELECT vorname,nachname,adresse FROM %s",table);
  
  if (!(mysql_connect(&mysql,server,"root",""))) 
    exiterr(1);
  
  if (mysql_select_db(&mysql,"kosta_personalien"))
    exiterr(2);
  
  if (mysql_query(&mysql,querystr))
    exiterr(3);
  
  if (!(res = mysql_store_result(&mysql)))
    exiterr(4);
  
  while((row = mysql_fetch_row(res))) {
    for (i=0 ; i < mysql_num_fields(res); i++) 
      printf("%s\n",row[i]);
  }
  
  if (!mysql_eof(res))
    exiterr(5);
  
  mysql_free_result(res);
  mysql_close(&mysql);
}




ok_function(GtkWidget *w,gpointer _parameters)
{
struct db_parms parameters;

parameters=*((struct db_parms*)_parameters);
printf("(struct db_parms*)_parameters: %d\n",(struct db_parms*)_parameters);
printf("OK pressed, inserting addresses from database\n");
get_sql_list(gtk_entry_get_text(GTK_ENTRY(GTK_COMBO( parameters.server)->entry)),\
	     gtk_entry_get_text(GTK_ENTRY(GTK_COMBO( parameters.db)->entry)),\
	     gtk_entry_get_text(GTK_ENTRY(GTK_COMBO( parameters.table)->entry)));
}

char *dbdialog()
{
  GtkWidget *dbwindow;
  GtkWidget *db_main_vbox;
  GtkWidget *db_select_labels_hbox;
  GtkWidget *db_select_hbox;
  GtkWidget *server_combo;
  GtkWidget *db_combo;
  GtkWidget *table_combo;
  GtkWidget *server_label,*db_label,*table_label;
  GtkWidget *allezeigen_label;
  GtkWidget *selectors_hbox;
  GtkWidget *whichname_select;
  GtkWidget *entbeg_combo;
  GtkWidget *name_entry;
  GtkWidget *ok_button;
  struct db_parms parameters;
  GList *nametypes=NULL;
  GList *servers=NULL;
  GList *databases=NULL;
  GList *tables=NULL;

  dbwindow = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (dbwindow), "Massenbrief db Vorsicht! Funktioniert noch nicht");



  db_main_vbox = gtk_vbox_new(FALSE,0);
  gtk_container_add(GTK_CONTAINER (dbwindow),db_main_vbox);

  db_select_labels_hbox = gtk_hbox_new(TRUE,3);
  gtk_container_add(GTK_CONTAINER (db_main_vbox),db_select_labels_hbox);

  server_label = gtk_label_new("Server");
  gtk_container_add(GTK_CONTAINER (db_select_labels_hbox),server_label);
  db_label = gtk_label_new("Datenbank");
  gtk_container_add(GTK_CONTAINER (db_select_labels_hbox),db_label);
  table_label = gtk_label_new("Tabelle");
  gtk_container_add(GTK_CONTAINER (db_select_labels_hbox),table_label);

  db_select_hbox = gtk_hbox_new(TRUE,3);
  gtk_container_add(GTK_CONTAINER (db_main_vbox),db_select_hbox);  

  server_combo = gtk_combo_new();
  parameters.server=server_combo;
  gtk_container_add(GTK_CONTAINER (db_select_hbox),server_combo);
  servers = g_list_append(servers, DEFAULT_SERVER);
  servers = g_list_append(servers, "example.silly.com");
  gtk_combo_set_popdown_strings(GTK_COMBO(server_combo),servers );

  db_combo = gtk_combo_new();
  parameters.db=db_combo;
  gtk_container_add(GTK_CONTAINER (db_select_hbox),db_combo);
  databases = g_list_append(databases, DEFAULT_DATABASE);
  gtk_combo_set_popdown_strings(GTK_COMBO(db_combo),databases );

  table_combo = gtk_combo_new();
  parameters.table=table_combo;
  gtk_container_add(GTK_CONTAINER (db_select_hbox),table_combo);
  tables = g_list_append(tables,DEFAULT_TABLE);
  tables = g_list_append(tables,"Musiker");
  tables = g_list_append(tables,"Sponsoren");
  gtk_combo_set_popdown_strings(GTK_COMBO(table_combo),tables );
  

  allezeigen_label = gtk_label_new("Alle auswaehlen wobei der");
  gtk_container_add(GTK_CONTAINER(db_main_vbox), allezeigen_label);

  selectors_hbox = gtk_hbox_new(FALSE,5);
  gtk_container_add(GTK_CONTAINER(db_main_vbox),selectors_hbox);

  whichname_select = gtk_combo_new();
  gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(whichname_select)->entry), "Nachname");
  nametypes = g_list_append(nametypes, "Vorname");
  nametypes = g_list_append(nametypes, "Nachname");
  gtk_combo_set_popdown_strings(GTK_COMBO(whichname_select),nametypes );
  gtk_container_add(GTK_CONTAINER(selectors_hbox),whichname_select);

  entbeg_combo = gtk_combo_new();
  //gtk_entry_set_text(GTK_ENTRY(GTK_COMBO(entbeg_combo)->entry), "enthaelt");
  nametypes=NULL;
  nametypes = g_list_append(nametypes, "enthaelt");
  nametypes = g_list_append(nametypes, "beginnt mit");
  nametypes = g_list_append(nametypes, "ist genau");
  gtk_combo_set_popdown_strings(GTK_COMBO(entbeg_combo),nametypes );
  gtk_container_add(GTK_CONTAINER(selectors_hbox),entbeg_combo);
  
  name_entry = gtk_entry_new();
  gtk_container_add(GTK_CONTAINER(selectors_hbox),name_entry);

  ok_button=gtk_button_new_with_label("OK");
  gtk_container_add(GTK_CONTAINER(db_main_vbox),ok_button);
  gtk_signal_connect(GTK_OBJECT (ok_button),"clicked",GTK_SIGNAL_FUNC(ok_function),(gpointer)&parameters);

  gtk_widget_show(ok_button);
  gtk_widget_show(name_entry);
  gtk_widget_show(selectors_hbox);
  gtk_widget_show(whichname_select);
  gtk_widget_show(entbeg_combo);
  gtk_widget_show(allezeigen_label);
  gtk_widget_show(db_select_labels_hbox);
  gtk_widget_show(server_label);
  gtk_widget_show(db_label);
  gtk_widget_show(table_label);

  gtk_widget_show(db_combo);
  gtk_widget_show(table_combo);
  gtk_widget_show(server_combo);
  gtk_widget_show(db_select_hbox);
  gtk_widget_show(db_main_vbox);
  gtk_widget_show(dbwindow);
}


/*
int main(int argc,char **argv)
     //debug only
{
  //get_sql_list("","");
gtk_init (&argc, &argv);

dbdialog();

gtk_main();
return (0);
}*/










